/*
 * Created on 10.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package saxparser;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * @author jjoller
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SAXCrimsonLocator extends DefaultHandler {

	private Locator locator;

	public void setDocumentLocator(Locator locator) {
		this.locator = locator;
	}

	private void printLocation(String s) {

		int line = locator.getLineNumber();
		int column = locator.getColumnNumber();
		System.out.println(s + " in Zeile " + line + "; Spalte " + column);

	}

	public void startDocument() {
		printLocation("startDocument()");
	}

	public void endDocument() {
		printLocation("endDocument()");
	}

	public void startElement(
		String namespaceURI,
		String localName,
		String qualifiedName,
		Attributes atts) {
		printLocation("startElement()");
	}

	public void endElement(
		String namespaceURI,
		String localName,
		String qualifiedName) {
		printLocation("endElement()");
	}

	public void characters(char[] text, int start, int length) {
		printLocation("characters()");
	}

	public void startPrefixMapping(String prefix, String uri) {
		printLocation("startPrefixMapping()");
	}

	public void endPrefixMapping(String prefix) {
		printLocation("endPrefixMapping()");
	}

	public void ignorableWhitespace(char[] text, int start, int length) {
		printLocation("ignorableWhitespace()");
	}

	public void processingInstruction(String target, String data) {
		printLocation("processingInstruction()");
	}

	public void skippedEntity(String name) {
		printLocation("skippedEntity()");
	}

	public static void main(String[] args) {
		System.setProperty("org.xml.sax.driver","org.apache.crimson.parser.XMLReaderImpl");
		String uri = "WhitespacesDTD.xml";

		try {
			XMLReader parser = XMLReaderFactory.createXMLReader();

			// Install the ContentHandler   
			ContentHandler handler = new SAXCrimsonLocator();
			parser.setContentHandler(handler);
			parser.parse(uri);

		} catch (Exception e) {
			System.err.println(e);
		}

	} 
}
