package saxparser;

import java.util.List;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;

/*
 * Created on 10.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author jjoller
 *
 * Dieser Handler liest mehrere XML Docs in einen StringBuffer
 * und speichert diesen serialisiert als String in einer Liste.
 */
public class SAXCrimsonMultiDocsHandler implements ContentHandler {

	/*
	 * Liste mit den XML Dokumenten als String (Objekte)
	 */
	private List documents;
	private StringBuffer currentDocument;
  
	public SAXCrimsonMultiDocsHandler(List documents) {
	  if (documents == null) {
		throw new NullPointerException(
		 "Leeres Dokument - Analyse unmglich");
	  }
	  this.documents = documents;   
	}

	/**
	 * ein neues Dokument wird eingelesen
	 * und in einen (neuen) StringBuffer eingelesen
	 */
	public void startDocument() {
	  currentDocument = new StringBuffer();
	}
  
	/**
	 * Ende eines XML DOkuments : 
	 * - hinzufgen des Dokuments als Zeichenkette in die 
	 *   Dokumenteliste
	 */
	public void endDocument() {
	  String text = currentDocument.toString();
	  documents.add(text);
	}
    
	/**
	 * extrahieren des Textes 
	 */
	public void characters(char[] text, int start, int length) {
	  currentDocument.append(text, start, length); 
	}  
    
	// leere Hanlder Methoden (Interface)
	public void setDocumentLocator(Locator locator) {}
	public void startPrefixMapping(String prefix, String uri) {}
	public void endPrefixMapping(String prefix) {}
	public void startElement(String namespaceURI, String localName,
	 String qualifiedName, Attributes atts) {}
	public void endElement(String namespaceURI, String localName,
	 String qualifiedName) {}
	public void ignorableWhitespace(char[] text, int start, 
	 int length) {}
	public void processingInstruction(String target, 
	 String data) {}
	public void skippedEntity(String name) {}
}
