/*
 * Created on 10.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package saxparser;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.NamespaceSupport;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * @author jjoller
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SAXCrimsonNamespaces extends DefaultHandler {
	private NamespaceSupport namespaces;
	private boolean needNewContext = true;

	public static void main(String[] args) throws Exception {

		// Lesen des XML Dokuments
		try {
			String xml_doc = "WhitespacesDTD.xml"; //"SOAPClientGetPrime.xml";
			/*
			 * Crimson
			 */
			System.setProperty(
				"org.xml.sax.driver",
				"org.apache.crimson.parser.XMLReaderImpl");
			XMLReader parser = XMLReaderFactory.createXMLReader();
			// Content Handler ab Interface
			ContentHandler handler = new SAXCrimsonNamespaces();
			parser.setContentHandler(handler);

			InputStream in = new FileInputStream(xml_doc);
			InputSource source = new InputSource(in);
			parser.parse(xml_doc);
			System.out.println("Das Dokument " + xml_doc + " ist wohlgeformt!");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char[] ch, int start, int length)
		throws SAXException {

		System.out.println("characters");
		for (int i = start; i < start + length; i++)
			System.out.print(ch[i]);
		System.out.println();

	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#endDocument()
	 */
	public void endDocument() throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#endElement(java.lang.String, java.lang.String, java.lang.String)
	 */
	public void endElement(String uri, String localName, String qName)
		throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#endPrefixMapping(java.lang.String)
	 */
	public void endPrefixMapping(String prefix) throws SAXException {
		System.out.println("endPrefixMapping");
		System.out.println("prefix : " + prefix);
		namespaces.popContext();
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ErrorHandler#error(org.xml.sax.SAXParseException)
	 */
	public void error(SAXParseException e) throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ErrorHandler#fatalError(org.xml.sax.SAXParseException)
	 */
	public void fatalError(SAXParseException e) throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#ignorableWhitespace(char[], int, int)
	 */
	public void ignorableWhitespace(char[] ch, int start, int length)
		throws SAXException {
		System.out.println("Ignorable Whitespace");
		for (int i = start; i < start + length; i++)
			System.out.print(ch[i]);
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.DTDHandler#notationDecl(java.lang.String, java.lang.String, java.lang.String)
	 */
	public void notationDecl(String name, String publicId, String systemId)
		throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#processingInstruction(java.lang.String, java.lang.String)
	 */
	public void processingInstruction(String target, String data)
		throws SAXException {
		System.out.println("Processing Instruction");
		System.out.println("Target : " + target + "; Data : " + data);
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.EntityResolver#resolveEntity(java.lang.String, java.lang.String)
	 */
	public InputSource resolveEntity(String publicId, String systemId)
		throws SAXException {
		return super.resolveEntity(publicId, systemId);
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#setDocumentLocator(org.xml.sax.Locator)
	 */
	public void setDocumentLocator(Locator locator) {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#skippedEntity(java.lang.String)
	 */
	public void skippedEntity(String name) throws SAXException {
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	public void startDocument() {
		namespaces = new NamespaceSupport();
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void startElement(
		String uri,
		String localName,
		String qName,
		Attributes attributes)
		throws SAXException {
		System.out.println("URI : " + uri);
		System.out.println("localName : " + uri);
		System.out.println("qName : " + uri);

		Attributes attr = attributes;
		System.out.println("Attribut Analyse");
		int iAttr = attr.getLength();
		System.out.println("Anzahl " + iAttr);
		for (int i = 0; i < iAttr; i++) {
			System.out.println("QName " + i + " : " + attr.getQName(i));
			System.out.println("Type " + i + " : " + attr.getType(i));
			System.out.println("URI " + i + " : " + attr.getURI(i));
			System.out.println("Value " + i + " : " + attr.getValue(i));
		}
		if (needNewContext)
			namespaces.pushContext();
		needNewContext = true;

		String value = attr.getValue("type");
		if (value != null) {
			String prefix = "";
			if (value.indexOf(':') >= 0) {
				prefix = value.substring(0, value.indexOf(':'));
			}
			String strURI = namespaces.getURI(prefix);
			System.out.println("prefix : " + prefix);
			System.out.println("Namespace URI : " + strURI);
		}
	}

	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#startPrefixMapping(java.lang.String, java.lang.String)
	 */
	public void startPrefixMapping(String prefix, String uri)
		throws SAXException {
		System.out.println("startPrefixMapping");
		System.out.println("Prefix : " + prefix);
		System.out.println("URI : " + uri);

		if (needNewContext) {
			namespaces.pushContext();
			needNewContext = false;
		}
		namespaces.declarePrefix(prefix, uri);

	}

	/* (non-Javadoc)
	 * @see org.xml.sax.DTDHandler#unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)
	 */
	public void unparsedEntityDecl(
		String name,
		String publicId,
		String systemId,
		String notationName)
		throws SAXException {
	}
}
