/*
 * Created on 10.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package saxparser;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.util.*;


public class SAXSpider extends DefaultHandler {

  // Need to keep track of where we've been 
  // so we don't get stuck in an infinite loop
  private List spideredURLs = new Vector();

  // This linked list keeps track of where we're going.
  // Although the LinkedList class does not guarantee queue like
  // access, I always access it in a first-in/first-out fashion.
  private LinkedList queue = new LinkedList();
  
  private String    currentURL;
  private XMLReader parser;
  
  public SAXSpider(XMLReader parser, String url) {
	this.parser = parser;
	this.currentURL = url;
  }
  
  public void endDocument() { 
    
	spideredURLs.add(currentURL);
	System.out.println("Visited " + currentURL);
	String url;
	try {
	  url = (String) queue.removeLast();
	}
	catch (NoSuchElementException e) {
	  // The queue is empty; we're finished.
	  return;
	}
	this.currentURL = url;
	try {
	  parser.parse(url);
	}
	catch (Exception ex) { 
	  // just skip this one and move on to the next
	  this.endDocument();
	}
    
  }

  public void startElement(String namespaceURI, String localName, 
   String qualifiedName, Attributes atts) {
    
	String type 
	 = atts.getValue("http://www.w3.org/1999/xlink", "type");
	if (type != null) {
	  String href 
	   = atts.getValue("http://www.w3.org/1999/xlink", "href");
	  if (href != null) {
		if (!spideredURLs.contains(href)) {
		  queue.addFirst(href);
		}
	  }
	}
    
  }
  

  public static void main(String[] args) {
    
	if (args.length == 0) {
	  System.out.println("Usage: java SAXSpider URL"); 
	} 
	String url = "http://www.joller-voss.ch/html/SiteMap.html";
    
	try {
	  XMLReader parser = XMLReaderFactory.createXMLReader(
		"org.apache.xerces.parsers.SAXParser"
	  );
      
	// Install the ContentHandler   
	ContentHandler spider = new SAXSpider(parser, url);   
	parser.setContentHandler(spider);
	parser.parse(url);

	}
	catch (Exception e) {
	  System.err.println(e);
	}
        
  } // end main

} // end SAXSpider
