package saxparser;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

/*
 * Created on 05.11.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author jjoller
 *
 * Im folgenden wird ein XML Dokument gelesen.
 * Falls das Dokument wohlgeformt ist,
 * wird keine Exception geworfen
 * sonst wird die SAXException geworfen.
 */
public class SAXWohlgeformt {

	public static void main(String[] args) {
				try {
					String xml_doc = "XMLEingabe.xml";
					/*
					 * Xerces
					 */
					 //System.setProperty("org.xml.sax.driver","org.apache.xerces.parsers.SAXParser");
					 /*
					  * Crimson
					  */
					System.setProperty("org.xml.sax.driver","org.apache.crimson.parser.XMLReaderImpl");
					XMLReader parser = XMLReaderFactory.createXMLReader();
					InputSource is = new InputSource();
					is.setByteStream(new FileInputStream(xml_doc));
					// URI
					//parser.parse("XMLEingabe.xml");
					parser.parse(is);
					System.out.println("Das Dokument "+xml_doc+" ist wohlgeformt");
				} catch (FileNotFoundException e) {
					System.err.println("Datei kann nicht gefunden werden");
					e.printStackTrace();
				} catch (SAXException e) {
					if (e.getMessage().equalsIgnoreCase("System property org.xml.sax.driver not specified")) {
						System.out.println("System Property wurde nicht gesetzt:");
						System.out.println("Sie mssen den SAX Driver mithilfe einer"+
							"System Property angeben");
						System.out.println("Beispiel : System.setProperty(\"org.xml.sax.driver\",\"org.apache.crimson.parser.XMLReaderImpl\");");
					} else 	System.err.println("Datei ist nicht wohlgeformt");					
					e.printStackTrace();
				} catch (IOException e) {
					System.err.println("Genereller IO Fehler");
					e.printStackTrace();
				}
	}
}